<?php
class Joovii_Sendleapi_AddressController extends Mage_Core_Controller_Front_Action
{
    

    private $_result = array (
            'query' => '',
            'suggestions' => array(),
            'data' => array(
                0 => array (
                    0 => array(
                            'city' => '',
                            'region_id' => '',
                            'postcode' => ''
                        )
                    )
            )
        );

    public function construct()
    {
        parent:: construct();
        $this->loadLayout();
        $this->renderLayout();
    }

    protected function _makeAutocomplete($query)
    {
        
       $this->_result['query'] = Mage::helper('core')->escapeHtml($query);
	   $url = 'http://api.geonames.org/postalCodeSearchJSON?placename_startsWith='.$query.'&maxRows=10&country=AU&username=nerdster';	
	   $url = str_replace(' ', '%20', $url);         
	   $suggestions = json_decode(file_get_contents($url),true);
	   //Mage::log("------- Estimate Shipping[_makeAutocomplete]--".$url."--->".print_r($suggestions, true)."<------" , null, "sendleapi1001.log");  
       $i = -1;
        if (!empty($suggestions['postalCodes'])) {
            //have results - load into result array
            $this->_result['data'] = array();
            foreach ($suggestions['postalCodes'] as $item) {
                $fulltext = $item['placeName'] .', ';
                $fulltext.= $item['postalCode'];
                $fulltext.= 'AU';

                if (!in_array($fulltext, $this->_result['suggestions'])) {
                    $i++;
                    $this->_result['suggestions'][$i] = $fulltext;
                }
                $this->_result['data'][$i][] = array(
                    'postcode'  => $item['postalCode'],
                    'city'  => $item['placeName'],
                    'country_id'=> 'AU',
                    'fulltext'  => $fulltext
                );
            }
        }
        $core_helper = Mage::helper('core');
        if (method_exists($core_helper, "jsonEncode")) {
            $result = Mage::helper('core')->jsonEncode($this->_result);
        } else {
            $result = Zend_Json::encode($this->_result);
        }
        return $result;
    }

    public function autocompletecartAction()
    {

        $query = $this->getRequest()->getParam('query');
        $country = 'AU';
        $html = $this->_makeAutocomplete($query);
		$this->getResponse()->setHeader('Content-Type', 'text/html', true)->setBody($html);   
		//print_r($query, true);
        //exit;
		return;		
    }
	
	protected function _isAllowed()
    {
        
    }

    
}
